package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import java.util.Objects;

/**
 * VoiceMailSettingRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class VoiceMailSettingRequest   {
  @JsonProperty("omadacId")
  private String omadacId;

  @JsonProperty("siteId")
  private String siteId;

  @JsonProperty("noAnswerTime")
  private Integer noAnswerTime;

  @JsonProperty("remoteAccessPin")
  private String remoteAccessPin;

  @JsonProperty("voiceMailInUsb")
  private Boolean voiceMailInUsb;

  @JsonProperty("greetingForVoiceMailMode")
  private Integer greetingForVoiceMailMode;

  @JsonProperty("greetingName")
  private String greetingName;

  @JsonProperty("usbUuid")
  private String usbUuid;

  @JsonProperty("voiceMailCapacity")
  private Integer voiceMailCapacity;

  @JsonProperty("enable")
  private Boolean enable;

  @JsonProperty("remoteAccessEnable")
  private Boolean remoteAccessEnable;

  @JsonProperty("duration")
  private Integer duration;

  public VoiceMailSettingRequest omadacId(String omadacId) {
    this.omadacId = omadacId;
    return this;
  }

  /**
   * Omadac ID.
   * @return omadacId
  */
  @ApiModelProperty(value = "Omadac ID.")


  public String getOmadacId() {
    return omadacId;
  }

  public void setOmadacId(String omadacId) {
    this.omadacId = omadacId;
  }

  public VoiceMailSettingRequest siteId(String siteId) {
    this.siteId = siteId;
    return this;
  }

  /**
   * Site ID.
   * @return siteId
  */
  @ApiModelProperty(value = "Site ID.")


  public String getSiteId() {
    return siteId;
  }

  public void setSiteId(String siteId) {
    this.siteId = siteId;
  }

  public VoiceMailSettingRequest noAnswerTime(Integer noAnswerTime) {
    this.noAnswerTime = noAnswerTime;
    return this;
  }

  /**
   * The no answer time of telephone number. Parameter [noAnswerTime] should be from 5 to 60
   * @return noAnswerTime
  */
  @ApiModelProperty(value = "The no answer time of telephone number. Parameter [noAnswerTime] should be from 5 to 60")


  public Integer getNoAnswerTime() {
    return noAnswerTime;
  }

  public void setNoAnswerTime(Integer noAnswerTime) {
    this.noAnswerTime = noAnswerTime;
  }

  public VoiceMailSettingRequest remoteAccessPin(String remoteAccessPin) {
    this.remoteAccessPin = remoteAccessPin;
    return this;
  }

  /**
   * Remote access pin.
   * @return remoteAccessPin
  */
  @ApiModelProperty(value = "Remote access pin.")

@Pattern(regexp="^\\d{4,8}$") 
  public String getRemoteAccessPin() {
    return remoteAccessPin;
  }

  public void setRemoteAccessPin(String remoteAccessPin) {
    this.remoteAccessPin = remoteAccessPin;
  }

  public VoiceMailSettingRequest voiceMailInUsb(Boolean voiceMailInUsb) {
    this.voiceMailInUsb = voiceMailInUsb;
    return this;
  }

  /**
   * Whether voice mail is in USB.
   * @return voiceMailInUsb
  */
  @ApiModelProperty(value = "Whether voice mail is in USB.")


  public Boolean getVoiceMailInUsb() {
    return voiceMailInUsb;
  }

  public void setVoiceMailInUsb(Boolean voiceMailInUsb) {
    this.voiceMailInUsb = voiceMailInUsb;
  }

  public VoiceMailSettingRequest greetingForVoiceMailMode(Integer greetingForVoiceMailMode) {
    this.greetingForVoiceMailMode = greetingForVoiceMailMode;
    return this;
  }

  /**
   * Parameter [greetingForVoiceMailMode] should be 0 or 1. 0: Default, 1: Custom.
   * @return greetingForVoiceMailMode
  */
  @ApiModelProperty(value = "Parameter [greetingForVoiceMailMode] should be 0 or 1. 0: Default, 1: Custom.")


  public Integer getGreetingForVoiceMailMode() {
    return greetingForVoiceMailMode;
  }

  public void setGreetingForVoiceMailMode(Integer greetingForVoiceMailMode) {
    this.greetingForVoiceMailMode = greetingForVoiceMailMode;
  }

  public VoiceMailSettingRequest greetingName(String greetingName) {
    this.greetingName = greetingName;
    return this;
  }

  /**
   * Greeting name.
   * @return greetingName
  */
  @ApiModelProperty(value = "Greeting name.")


  public String getGreetingName() {
    return greetingName;
  }

  public void setGreetingName(String greetingName) {
    this.greetingName = greetingName;
  }

  public VoiceMailSettingRequest usbUuid(String usbUuid) {
    this.usbUuid = usbUuid;
    return this;
  }

  /**
   * USB UUID.
   * @return usbUuid
  */
  @ApiModelProperty(value = "USB UUID.")


  public String getUsbUuid() {
    return usbUuid;
  }

  public void setUsbUuid(String usbUuid) {
    this.usbUuid = usbUuid;
  }

  public VoiceMailSettingRequest voiceMailCapacity(Integer voiceMailCapacity) {
    this.voiceMailCapacity = voiceMailCapacity;
    return this;
  }

  /**
   * The capacity of voice mail.
   * @return voiceMailCapacity
  */
  @ApiModelProperty(value = "The capacity of voice mail.")


  public Integer getVoiceMailCapacity() {
    return voiceMailCapacity;
  }

  public void setVoiceMailCapacity(Integer voiceMailCapacity) {
    this.voiceMailCapacity = voiceMailCapacity;
  }

  public VoiceMailSettingRequest enable(Boolean enable) {
    this.enable = enable;
    return this;
  }

  /**
   * Whether to enable voice mail settings.
   * @return enable
  */
  @ApiModelProperty(required = true, value = "Whether to enable voice mail settings.")
  @NotNull


  public Boolean getEnable() {
    return enable;
  }

  public void setEnable(Boolean enable) {
    this.enable = enable;
  }

  public VoiceMailSettingRequest remoteAccessEnable(Boolean remoteAccessEnable) {
    this.remoteAccessEnable = remoteAccessEnable;
    return this;
  }

  /**
   * Whether voice mail allows remote access.
   * @return remoteAccessEnable
  */
  @ApiModelProperty(value = "Whether voice mail allows remote access.")


  public Boolean getRemoteAccessEnable() {
    return remoteAccessEnable;
  }

  public void setRemoteAccessEnable(Boolean remoteAccessEnable) {
    this.remoteAccessEnable = remoteAccessEnable;
  }

  public VoiceMailSettingRequest duration(Integer duration) {
    this.duration = duration;
    return this;
  }

  /**
   * Parameter [duration] should be from 20 to 120.
   * @return duration
  */
  @ApiModelProperty(value = "Parameter [duration] should be from 20 to 120.")


  public Integer getDuration() {
    return duration;
  }

  public void setDuration(Integer duration) {
    this.duration = duration;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    VoiceMailSettingRequest voiceMailSettingRequest = (VoiceMailSettingRequest) o;
    return Objects.equals(this.omadacId, voiceMailSettingRequest.omadacId) &&
        Objects.equals(this.siteId, voiceMailSettingRequest.siteId) &&
        Objects.equals(this.noAnswerTime, voiceMailSettingRequest.noAnswerTime) &&
        Objects.equals(this.remoteAccessPin, voiceMailSettingRequest.remoteAccessPin) &&
        Objects.equals(this.voiceMailInUsb, voiceMailSettingRequest.voiceMailInUsb) &&
        Objects.equals(this.greetingForVoiceMailMode, voiceMailSettingRequest.greetingForVoiceMailMode) &&
        Objects.equals(this.greetingName, voiceMailSettingRequest.greetingName) &&
        Objects.equals(this.usbUuid, voiceMailSettingRequest.usbUuid) &&
        Objects.equals(this.voiceMailCapacity, voiceMailSettingRequest.voiceMailCapacity) &&
        Objects.equals(this.enable, voiceMailSettingRequest.enable) &&
        Objects.equals(this.remoteAccessEnable, voiceMailSettingRequest.remoteAccessEnable) &&
        Objects.equals(this.duration, voiceMailSettingRequest.duration);
  }

  @Override
  public int hashCode() {
    return Objects.hash(omadacId, siteId, noAnswerTime, remoteAccessPin, voiceMailInUsb, greetingForVoiceMailMode, greetingName, usbUuid, voiceMailCapacity, enable, remoteAccessEnable, duration);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class VoiceMailSettingRequest {\n");
    
    sb.append("    omadacId: ").append(toIndentedString(omadacId)).append("\n");
    sb.append("    siteId: ").append(toIndentedString(siteId)).append("\n");
    sb.append("    noAnswerTime: ").append(toIndentedString(noAnswerTime)).append("\n");
    sb.append("    remoteAccessPin: ").append(toIndentedString(remoteAccessPin)).append("\n");
    sb.append("    voiceMailInUsb: ").append(toIndentedString(voiceMailInUsb)).append("\n");
    sb.append("    greetingForVoiceMailMode: ").append(toIndentedString(greetingForVoiceMailMode)).append("\n");
    sb.append("    greetingName: ").append(toIndentedString(greetingName)).append("\n");
    sb.append("    usbUuid: ").append(toIndentedString(usbUuid)).append("\n");
    sb.append("    voiceMailCapacity: ").append(toIndentedString(voiceMailCapacity)).append("\n");
    sb.append("    enable: ").append(toIndentedString(enable)).append("\n");
    sb.append("    remoteAccessEnable: ").append(toIndentedString(remoteAccessEnable)).append("\n");
    sb.append("    duration: ").append(toIndentedString(duration)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

